import * as antd_es_config_provider from 'antd/es/config-provider';
import * as antd_es__util_statusUtils from 'antd/es/_util/statusUtils';
import * as antd_es_button from 'antd/es/button';
import * as antd_es_upload_Upload from 'antd/es/upload/Upload';
import * as antd_es_transfer from 'antd/es/transfer';
import * as antd_es_slider from 'antd/es/slider';
import * as antd_es_radio_radioButton from 'antd/es/radio/radioButton';
import * as antd_es_input_OTP from 'antd/es/input/OTP';
import * as antd_es_input_TextArea from 'antd/es/input/TextArea';
import * as antd_es_input from 'antd/es/input';
import { SearchProps as SearchProps$1, TextAreaProps as TextAreaProps$1, PasswordProps as PasswordProps$1 } from 'antd/es/input';
import * as antd_es_date_picker_generatePicker from 'antd/es/date-picker/generatePicker';
import * as antd_es_date_picker from 'antd/es/date-picker';
import { RangePickerProps } from 'antd/es/date-picker';
import * as antd_es_cascader_Panel from 'antd/es/cascader/Panel';
import * as antd_es_cascader from 'antd/es/cascader';
import * as antd from 'antd';
import { FormRule, FormItemProps, SliderSingleProps, AutoCompleteProps as AutoCompleteProps$1, CascaderProps as CascaderProps$1, CheckboxProps as CheckboxProps$1, DatePickerProps as DatePickerProps$1, InputProps as InputProps$1, InputNumberProps as InputNumberProps$1, MentionProps as MentionProps$1, RadioProps as RadioProps$1, RateProps as RateProps$1, SelectProps as SelectProps$1, SwitchProps as SwitchProps$1, TimePickerProps as TimePickerProps$1, TransferProps as TransferProps$1, TreeSelectProps as TreeSelectProps$1, UploadProps as UploadProps$1, RadioGroupProps as RadioGroupProps$1, TimeRangePickerProps } from 'antd';
import * as antd_es__util_type from 'antd/es/_util/type';
import { CheckboxGroupProps as CheckboxGroupProps$1 } from 'antd/es/checkbox';
import { MentionsRef } from 'antd/es/mentions';
import { DraggerProps as DraggerProps$1 } from 'antd/es/upload';
import * as React from 'react';
import { JSXElementConstructor, ComponentProps, PropsWithoutRef, ReactNode } from 'react';
import * as react_jsx_runtime from 'react/jsx-runtime';
import { FormInstance } from 'antd/es/form';
import { NamePath } from 'antd/es/form/interface';

type PlusShortRule = 'required' | `required=${string}` | 'string' | 'pureString' | 'number' | 'array' | 'boolean' | 'url' | 'email' | `len=${number}` | `max=${number}` | `min=${number}` | FormRule;
type ConflictProps = 'className' | 'style' | 'name' | 'tooltip';
type ReplaceProps = {
    selfClass?: SliderSingleProps['className'];
    selfStyle?: SliderSingleProps['style'];
    selfName?: string;
    selfTooltip?: SliderSingleProps['tooltip'];
};
type PlusProps<P> = Omit<P, ConflictProps> & ReplaceProps & Omit<FormItemProps, 'rules'> & {
    rules?: PlusShortRule[];
};
declare const create: <T extends JSXElementConstructor<any>>(Field: T, getDefaultFieldProps?: (p: ComponentProps<T>) => Partial<ComponentProps<T>>) => Omit<T, "label"> & React.ForwardRefExoticComponent<PropsWithoutRef<PlusProps<ComponentProps<T>>> & React.RefAttributes<unknown>>;

type WatchProps = {
    name?: NamePath;
    list?: NamePath[];
    children?: (next: any, prev: any, form: FormInstance) => ReactNode;
    onlyValid?: boolean;
    onChange?: (next: any, prev: any, form: FormInstance) => void;
};
/**
 * Watch - 用于监听其它字段的值
 */
declare const Watch: (props: WatchProps) => react_jsx_runtime.JSX.Element;

type WrapperColProps = Omit<FormItemProps, 'label' | 'colon'>;
declare const WrapperCol: (props: WrapperColProps) => react_jsx_runtime.JSX.Element;

interface MentionsConfig {
    prefix?: string | string[];
    split?: string;
}
interface MentionsEntity {
    prefix: string;
    value: string;
}
type CompoundedComponent = React.ForwardRefExoticComponent<MentionProps$1 & React.RefAttributes<MentionsRef>> & {
    Option: typeof Option;
    _InternalPanelDoNotUseOrYouWillBeFired: any;
    getMentions: (value: string, config?: MentionsConfig) => MentionsEntity[];
};

type AutoCompleteProps = PlusProps<AutoCompleteProps$1>;
type CascaderProps = PlusProps<CascaderProps$1>;
type CheckboxProps = PlusProps<CheckboxProps$1>;
type DatePickerProps = PlusProps<DatePickerProps$1>;
type InputProps = PlusProps<InputProps$1>;
type InputNumberProps = PlusProps<InputNumberProps$1>;
type MentionProps = PlusProps<MentionProps$1>;
type RadioProps = PlusProps<RadioProps$1>;
type RateProps = PlusProps<RateProps$1>;
type SelectProps = PlusProps<SelectProps$1>;
type SliderProps = PlusProps<SliderSingleProps>;
type SwitchProps = PlusProps<SwitchProps$1>;
type TimePickerProps = PlusProps<TimePickerProps$1>;
type TransferProps = PlusProps<TransferProps$1<any>>;
type TreeSelectProps = PlusProps<TreeSelectProps$1>;
type UploadProps = PlusProps<UploadProps$1>;
declare const AutoComplete: Omit<(<ValueType = any, OptionType extends BaseOptionType | DefaultOptionType = DefaultOptionType>(props: React.PropsWithChildren<AutoCompleteProps$1<ValueType, OptionType>> & React.RefAttributes<BaseSelectRef>) => React.ReactElement) & {
    displayName?: string;
    Option: any;
    _InternalPanelDoNotUseOrYouWillBeFired: (props: antd_es__util_type.AnyObject) => React.JSX.Element;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<AutoCompleteProps$1<unknown, any> & {
    children?: React.ReactNode | undefined;
} & React.RefAttributes<BaseSelectRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Cascader: Omit<(<OptionType extends DefaultOptionType = DefaultOptionType, ValueField extends keyof OptionType = keyof OptionType>(props: React.PropsWithChildren<antd.CascaderAutoProps<OptionType, ValueField>> & React.RefAttributes<antd_es_cascader.CascaderRef>) => React.ReactElement) & {
    displayName: string;
    SHOW_PARENT: "SHOW_PARENT";
    SHOW_CHILD: "SHOW_CHILD";
    Panel: typeof antd_es_cascader_Panel.default;
    _InternalPanelDoNotUseOrYouWillBeFired: (props: antd_es__util_type.AnyObject) => React.JSX.Element;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<React.PropsWithChildren<antd.CascaderAutoProps<DefaultOptionType, string | number | symbol>> & React.RefAttributes<antd_es_cascader.CascaderRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Checkbox: Omit<React.ForwardRefExoticComponent<CheckboxProps$1 & React.RefAttributes<CheckboxRef>> & {
    Group: <T = any>(props: CheckboxGroupProps$1<T> & React.RefAttributes<HTMLDivElement>) => React.ReactElement;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<CheckboxProps$1 & React.RefAttributes<CheckboxRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const DatePicker: Omit<antd_es_date_picker.DatePickerType, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<Omit<antd_es_date_picker_generatePicker.PickerProps<DateType>, "onChange" | "value" | "defaultValue" | "onOk"> & React.RefAttributes<PickerRef> & {
    defaultValue?: unknown;
    value?: unknown;
    onChange?: ((date: unknown, dateString: string | string[]) => void) | undefined;
    onOk?: ((date: unknown) => void) | undefined;
}>, "ref"> & React.RefAttributes<unknown>>;
declare const Input: Omit<React.ForwardRefExoticComponent<InputProps$1 & React.RefAttributes<InputRef>> & {
    Group: React.FC<antd_es_input.GroupProps>;
    Search: React.ForwardRefExoticComponent<SearchProps$1 & React.RefAttributes<InputRef>>;
    TextArea: React.ForwardRefExoticComponent<TextAreaProps$1 & React.RefAttributes<antd_es_input_TextArea.TextAreaRef>>;
    Password: React.ForwardRefExoticComponent<PasswordProps$1 & React.RefAttributes<InputRef>>;
    OTP: React.ForwardRefExoticComponent<antd_es_input_OTP.OTPProps & React.RefAttributes<antd_es_input_OTP.OTPRef>>;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<InputProps$1 & React.RefAttributes<InputRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const InputNumber: Omit<(<T extends ValueType = ValueType>(props: React.PropsWithChildren<InputNumberProps$1<T>> & React.RefAttributes<HTMLInputElement>) => React.ReactElement) & {
    displayName?: string;
    _InternalPanelDoNotUseOrYouWillBeFired: React.FC<InputNumberProps$1<ValueType>>;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<InputNumberProps$1<ValueType> & {
    children?: React.ReactNode | undefined;
} & React.RefAttributes<HTMLInputElement>>, "ref"> & React.RefAttributes<unknown>>;
declare const Mentions: Omit<CompoundedComponent, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<MentionProps$1 & React.RefAttributes<MentionsRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Radio: Omit<React.ForwardRefExoticComponent<RadioProps$1 & React.RefAttributes<RadioRef>> & {
    Group: React.MemoExoticComponent<React.ForwardRefExoticComponent<RadioGroupProps$1 & React.RefAttributes<HTMLDivElement>>>;
    Button: React.ForwardRefExoticComponent<antd_es_radio_radioButton.RadioButtonProps & React.RefAttributes<RadioRef>>;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<RadioProps$1 & React.RefAttributes<RadioRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Rate: Omit<React.ForwardRefExoticComponent<RateProps$1 & React.RefAttributes<RateRef>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<RateProps$1 & React.RefAttributes<RateRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Select: Omit<(<ValueType = any, OptionType extends BaseOptionType | DefaultOptionType = DefaultOptionType>(props: React.PropsWithChildren<SelectProps$1<ValueType, OptionType>> & React.RefAttributes<BaseSelectRef>) => React.ReactElement) & {
    displayName?: string;
    SECRET_COMBOBOX_MODE_DO_NOT_USE: string;
    Option: any;
    OptGroup: any;
    _InternalPanelDoNotUseOrYouWillBeFired: (props: antd_es__util_type.AnyObject) => React.JSX.Element;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<SelectProps$1<unknown, any> & {
    children?: React.ReactNode | undefined;
} & React.RefAttributes<BaseSelectRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Slider: Omit<React.ForwardRefExoticComponent<(SliderSingleProps | antd_es_slider.SliderRangeProps) & React.RefAttributes<SliderRef>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<(SliderSingleProps | antd_es_slider.SliderRangeProps) & React.RefAttributes<SliderRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Switch: Omit<React.ForwardRefExoticComponent<SwitchProps$1 & React.RefAttributes<HTMLButtonElement>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<SwitchProps$1 & React.RefAttributes<HTMLButtonElement>>, "ref"> & React.RefAttributes<unknown>>;
declare const TimePicker: Omit<React.ForwardRefExoticComponent<Omit<TimePickerProps$1, "ref"> & React.RefAttributes<PickerRef>> & {
    RangePicker: React.ForwardRefExoticComponent<TimeRangePickerProps & React.RefAttributes<PickerRef>>;
    _InternalPanelDoNotUseOrYouWillBeFired: (props: antd_es__util_type.AnyObject) => React.JSX.Element;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<Omit<TimePickerProps$1, "ref"> & React.RefAttributes<PickerRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Transfer: Omit<{
    <RecordType extends antd_es_transfer.TransferItem = antd_es_transfer.TransferItem>(props: TransferProps$1<RecordType>): React.ReactElement<any, string | React.JSXElementConstructor<any>>;
    displayName: string;
    List: {
        <RecordType extends antd_es_transfer.KeyWiseTransferItem>(props: antd_es_transfer.TransferListProps<RecordType>): React.JSX.Element;
        displayName: string;
    };
    Search: React.FC<antd_es_transfer.TransferSearchProps>;
    Operation: React.FC<antd_es_transfer.TransferOperationProps>;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<TransferProps$1<antd_es_transfer.TransferItem>>, "ref"> & React.RefAttributes<unknown>>;
declare const TreeSelect: Omit<(<ValueType = any, OptionType extends DataNode = DataNode>(props: React.PropsWithChildren<TreeSelectProps$1<ValueType, OptionType>> & React.RefAttributes<BaseSelectRef>) => React.ReactElement) & {
    displayName?: string;
    TreeNode: any;
    SHOW_ALL: any;
    SHOW_PARENT: any;
    SHOW_CHILD: any;
    _InternalPanelDoNotUseOrYouWillBeFired: (props: antd_es__util_type.AnyObject) => React.JSX.Element;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<TreeSelectProps$1<unknown, DataNode> & {
    children?: React.ReactNode | undefined;
} & React.RefAttributes<BaseSelectRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Upload: Omit<React.ForwardRefExoticComponent<UploadProps$1<any> & React.RefAttributes<antd_es_upload_Upload.UploadRef<any>>> & {
    <U extends any>(props: UploadProps$1<U> & {
        children?: React.ReactNode | undefined;
    } & React.RefAttributes<any>): React.ReactElement;
    Dragger: React.ForwardRefExoticComponent<UploadProps$1<any> & {
        height?: number;
    } & React.RefAttributes<antd_es_upload_Upload.UploadRef<any>>>;
    LIST_IGNORE: string;
}, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<UploadProps$1<any> & {
    children?: React.ReactNode | undefined;
} & React.RefAttributes<any>>, "ref"> & React.RefAttributes<unknown>>;
type CheckboxGroupProps = PlusProps<CheckboxGroupProps$1>;
type DateRangeProps = PlusProps<RangePickerProps>;
type TextAreaProps = PlusProps<TextAreaProps$1>;
type SearchProps = PlusProps<SearchProps$1>;
type PasswordProps = PlusProps<PasswordProps$1>;
type RadioGroupProps = PlusProps<RadioGroupProps$1>;
type TimeRangeProps = PlusProps<TimeRangePickerProps>;
type DraggerProps = PlusProps<DraggerProps$1>;
declare const CheckboxGroup: Omit<(<T = any>(props: CheckboxGroupProps$1<T> & React.RefAttributes<HTMLDivElement>) => React.ReactElement), "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<CheckboxGroupProps$1<unknown> & React.RefAttributes<HTMLDivElement>>, "ref"> & React.RefAttributes<unknown>>;
declare const DateRange: Omit<React.ForwardRefExoticComponent<Omit<any, "locale" | "generateConfig" | "hideHeader"> & {
    locale?: antd_es_date_picker_generatePicker.PickerLocale;
    size?: antd_es_button.ButtonSize;
    placement?: "bottomLeft" | "bottomRight" | "topLeft" | "topRight";
    bordered?: boolean;
    status?: antd_es__util_statusUtils.InputStatus;
    variant?: antd_es_config_provider.Variant;
    dropdownClassName?: string;
    popupClassName?: string;
    rootClassName?: string;
    popupStyle?: React.CSSProperties;
} & React.RefAttributes<any>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<Omit<any, "locale" | "generateConfig" | "hideHeader"> & {
    locale?: antd_es_date_picker_generatePicker.PickerLocale;
    size?: antd_es_button.ButtonSize;
    placement?: "bottomLeft" | "bottomRight" | "topLeft" | "topRight";
    bordered?: boolean;
    status?: antd_es__util_statusUtils.InputStatus;
    variant?: antd_es_config_provider.Variant;
    dropdownClassName?: string;
    popupClassName?: string;
    rootClassName?: string;
    popupStyle?: React.CSSProperties;
} & React.RefAttributes<any>>, "ref"> & React.RefAttributes<unknown>>;
declare const TextArea: Omit<React.ForwardRefExoticComponent<TextAreaProps$1 & React.RefAttributes<antd_es_input_TextArea.TextAreaRef>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<TextAreaProps$1 & React.RefAttributes<antd_es_input_TextArea.TextAreaRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Search: Omit<React.ForwardRefExoticComponent<SearchProps$1 & React.RefAttributes<InputRef>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<SearchProps$1 & React.RefAttributes<InputRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Password: Omit<React.ForwardRefExoticComponent<PasswordProps$1 & React.RefAttributes<InputRef>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<PasswordProps$1 & React.RefAttributes<InputRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const RadioGroup: Omit<React.MemoExoticComponent<React.ForwardRefExoticComponent<RadioGroupProps$1 & React.RefAttributes<HTMLDivElement>>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<Omit<RadioGroupProps$1 & React.RefAttributes<HTMLDivElement>, "ref"> & {
    ref?: ((instance: HTMLDivElement | null) => void | React.DO_NOT_USE_OR_YOU_WILL_BE_FIRED_CALLBACK_REF_RETURN_VALUES[keyof React.DO_NOT_USE_OR_YOU_WILL_BE_FIRED_CALLBACK_REF_RETURN_VALUES]) | React.RefObject<HTMLDivElement> | null | undefined;
}>, "ref"> & React.RefAttributes<unknown>>;
declare const TimeRange: Omit<React.ForwardRefExoticComponent<TimeRangePickerProps & React.RefAttributes<PickerRef>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<TimeRangePickerProps & React.RefAttributes<PickerRef>>, "ref"> & React.RefAttributes<unknown>>;
declare const Dragger: Omit<React.ForwardRefExoticComponent<UploadProps$1<any> & {
    height?: number;
} & React.RefAttributes<antd_es_upload_Upload.UploadRef<any>>>, "label"> & React.ForwardRefExoticComponent<Omit<PlusProps<UploadProps$1<any> & {
    height?: number;
} & React.RefAttributes<antd_es_upload_Upload.UploadRef<any>>>, "ref"> & React.RefAttributes<unknown>>;

export { AutoComplete, type AutoCompleteProps, Cascader, type CascaderProps, Checkbox, CheckboxGroup, type CheckboxGroupProps, type CheckboxProps, DatePicker, type DatePickerProps, DateRange, type DateRangeProps, Dragger, type DraggerProps, Input, InputNumber, type InputNumberProps, type InputProps, type MentionProps, Mentions, Password, type PasswordProps, type PlusProps, type PlusShortRule, Radio, RadioGroup, type RadioGroupProps, type RadioProps, Rate, type RateProps, Search, type SearchProps, Select, type SelectProps, Slider, type SliderProps, Switch, type SwitchProps, TextArea, type TextAreaProps, TimePicker, type TimePickerProps, TimeRange, type TimeRangeProps, Transfer, type TransferProps, TreeSelect, type TreeSelectProps, Upload, type UploadProps, Watch, type WatchProps, WrapperCol, type WrapperColProps, create };
